<?php

class SlideImage extends DataObject {

	public function GridThumb() {
		$Image = $this->Image();
		if ( $Image )
			return $Image->CMSThumbnail();
		else
			return null;
	}

	function getCMSFields() {
		$fields = parent::getCMSFields();
		$ImageField = new UploadField('Image', 'Image');
		$ImageField->getValidator()->allowedExtensions = array('jpg', 'gif', 'png');
		$ImageField->setFolderName('Uploads/SlideImages');
		$ImageField->setConfig('allowedMaxFileNumber', 1);

	   	$fields->addFieldsToTab('Root.Main',array(
	   		new TextField('Name'),
	   		CheckboxField::create('ShowSlide')->setTitle('Show Slide'),
			TextareaField::create('Description'),
			$ImageField,
			new TreeDropdownField("PageLinkID", "Choose a page to link to:", "SiteTree")
		));
		$fields->removeFieldsFromTab('Root.Main',array(
			'SortOrder',
			'PageID'));
		$this->extend('updateCMSFields', $fields);
		return $fields;
	}

	public function Thumbnail() {
		return $this->Image()->CroppedImage(80,80);
	}

	public function Large() {
		if ($this->Image()->GetHeight() > 700) {
			return $this->Image()->SetHeight(700);
		} else {
			return $this->Image();
		}
	}

	public function Slide() {
		if ($this->Page() && $this->Page()->SliderWidth && $this->Page()->SliderHeight) {
			$width = $this->Page()->SliderWidth;
			$height = $this->Page()->SliderHeight;
		} else {
			$width = 640;
			$height = 400;
		}
		return $this->Image()->PaddedImage($width, $height);
	}

	public function CroppedSlide() {
		if ($this->Page() && $this->Page()->SliderWidth && $this->Page()->SliderHeight) {
			$width = $this->Page()->SliderWidth;
			$height = $this->Page()->SliderHeight;
		} else {
			$width = 640;
			$height = 400;
		}
		return $this->Image()->CroppedImage($width, $height);
	}

	function canCreate($member=null) { return true; }
	function canEdit($member=null) { return true; }
	function canDelete($member=null) { return true; }
	function canView($member=null) { return true; }
}